<script lang="ts">
	import { CornerDownRightIcon } from 'svelte-feather-icons';

	import MoveButtons from './MoveButtons.svelte';
	import { onMount } from 'svelte';
	import ProductItem from './ProductItem.svelte';
	import type { Category, ProductFB } from '../../../(admin)/admin/produits/type';

	export let index: number;
	export let productType: {
		category: Category;
		products: ProductFB[];
	};
	[];
	export let products: any = [];

	let show: number = -1;

	const bgColors: string[] = ['333333', '222222'];

	let ProductScrollLeft: number[] = [];
	let ProductClientWidth: number[] = [];
	let ProductScrollWidth: number[] = [];

	onMount(() => {
		ProductScrollLeft = [];
		ProductClientWidth = [];
		ProductScrollWidth = [];

		for (let i = 0; i < products.length; i++) {
			ProductScrollLeft.push(0);
			ProductClientWidth.push(document.getElementById('type-' + i)?.clientWidth);
			ProductScrollWidth.push(document.getElementById('type-' + i)?.scrollWidth);
		}
	});
</script>

<div
	class="flex flex-col gap-4 w-full py-8 md:px-8 px-2 text-white"
	style={'background-color: #' + bgColors[index % 2] + ';'}
	on:mouseover={() => {
		show = index;
	}}
	on:focus={() => {
		show = index;
	}}
	on:mouseleave={() => {
		show = -1;
	}}
>
	<div class="flex flex-col gap-1">
		<h2 class="text-2xl font-bold">{productType.category.name}</h2>
		{#if productType.category.description}
			<h3 class="text-lg flex items-center gap-2">
				<div class="text-primary-500">
					<CornerDownRightIcon />
				</div>
				{@html productType.category.description}
			</h3>
		{/if}
	</div>
	{#if productType.products.length > 0}
		<div class="relative">
			<div
				id={'type-' + index}
				class="relative scroll-container flex flex-row touch-pan-x overflow-x-auto h-60 touch-pan-y gap-4"
				on:scroll={(event) => {
					ProductScrollLeft[index] = event.target.scrollLeft;
					ProductClientWidth[index] = event.target.clientWidth;
					ProductScrollWidth[index] = event.target.scrollWidth;
				}}
			>
				{#each productType.products as product}
					<ProductItem {index} {product} />
				{/each}
			</div>
			<!-- <MoveButtons
				{index}
				{show}
				scrollLeft={ProductScrollLeft[index]}
				clientWidth={ProductClientWidth[index]}
				scrollWidth={ProductScrollWidth[index]}
			/> -->
		</div>
	{/if}
</div>

<style>
	.scroll-container::-webkit-scrollbar {
		/* display: none; */
	}

	.scroll-container {
		/* IE and Edge */
		/* -ms-overflow-style: none;  */
		/* Firefox */
		/* scrollbar-width: none;  */
		overflow-y: hidden;
	}
</style>
